<?php
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ImportacaoCatracaFactories {

    protected  $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    //VERIFICA SE O CRACHÁ DO FUNCIONÁRIO ESTÁ CADASTRADO NA FILIAL.
    public function getIDCRALOGCAT($params){
        $IDCRALOGCAT = $this->connection->fetchAssoc(Utilities\Query::GET_IDCRALOGCAT, $params);

        if($IDCRALOGCAT){
            $IDCRALOGCAT = '2'; // OK
        }else{
            $IDCRALOGCAT = '3'; //INVÁLIDO
        }
        
        return $IDCRALOGCAT;
    }
    
    // VERIFICA SE A CATRACA ESTÁ CADASTRADA NO CAIXA
    public function getCAIXA($params){
        $IDCATLOGCAT = $this->connection->fetchAssoc(Utilities\Query::GET_CAIXA_IMPORT_CATRACA, $params);
        
        if($IDCATLOGCAT){
            $IDCATLOGCAT = '2'; // OK
        }else{
            $IDCATLOGCAT = '3'; // INVÁLIDO
        }
        
        return $IDCATLOGCAT;
    }
    
    //VERIFICA SE O SERVIÇO ESTÁ DEFINIDO
    public function getIDSERLOGCAT($params){
        $IDSERLOGCAT = $this->connection->fetchAssoc(Utilities\Query::GET_IDSERLOGCAT_IMPORT_CATRACA, $params);
        
        if($IDSERLOGCAT){
            $IDSERLOGCAT = '2'; // OK
        }else{
            $IDSERLOGCAT = '3';; // INVÁLIDO
        }
        
        return $IDSERLOGCAT;
    }
    
    // VERIFICA A EXISTÊNCIA DO PRODUTO
    public function getIDPROLOGCAT($params){
        $IDPROLOGCAT = $this->connection->fetchAssoc(Utilities\Query::GET_IDPROLOGCAT_IMPORT_CATRACA, $params);
        
        if($IDPROLOGCAT){
            $IDPROLOGCAT = '2'; // OK
        }else{
            $IDPROLOGCAT = '3';; // INVÁLIDO
        }
        
        return $IDPROLOGCAT;
    }
    
    // INSERT
    public function insertDadosCatraca($params, $Query){
        $return = $this->connection->executeQuery($Query, $params);
    }
    
    // UPDATE DO IDDATLOGCAT
    public function setIDDATLOGCAT($params){
        $this->connection->fetchAssoc(Utilities\Query::UPDATE_IDDATLOGCAT, $params);
    }
    
    // DELETE ROW
    public function deleteRowLogCatraca($params){
        $this->connection->executeQuery(Utilities\Query::DELETE_ROW_IMPORTDADOSCATRACA, $params);
    }
    
    public function getCamposLayout($params){
        return $this->connection->fetchAll(Utilities\Query::GET_LAYOUT_CATRACA, $params);
    }
    
    public function getNmOper($params){
        return $this->connection->fetchAssoc(Utilities\Query::GET_NOME_OPERADOR, $params);
    }
    
    public function getCDIDCONSUMID($params){
        return $this->connection->fetchAssoc(Utilities\Query::GET_CDIDCONSUMID, $params);
    }
    
} 