<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DTO;

class ObservacaoService {
    
    protected $entityManager;
    
    const CDGRUPOOBRIG = 'CDGRUPOOBRIG';
    const NRORG = 'NRORG';
    const CDGRPOCOR = 'CDGRPOCOR';
    const CDOCORR = 'CDOCORR';
    
	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function saveProdutos ($CDARVPRODINI, $CDARVPRODFIM, $CDGRPOCOR, $CDOCORR, $CDOPERINCLUSAO, $CDOPERULTATU,
            $NRORGULTATU, $NRORGINCLUSAO, $DTINCLUSAO, $DTULTATUPOCO, $DTULTATU, $NRORG, $PRODUTOS, $CDNVPRODUTO) {
                
        $success = true;
        
        if(empty($PRODUTOS)){
            $paramsCDPRODUTO = array (
                ':NRORG'           => $NRORG,
                ':CDGRPOCOR'      => $CDGRPOCOR,
                ':CDOCORR'        => $CDOCORR,
    			':CDARVPRODINI' => $CDARVPRODINI,
    			':CDARVPRODFIM' => $CDARVPRODFIM,
    			':CDNVPRODUTO' => $CDNVPRODUTO
            );
            
            $data = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCTS_INI_FIN, $paramsCDPRODUTO);
            if(empty($data)){
                $success = false;
            }
            
            foreach ($data as $produto => $value) {
                $paramsSave = array (
                  ':CDPRODUTO'      => $value['CDPRODUTO'],
                  ':CDGRPOCOR'      => $CDGRPOCOR,
                  ':CDOCORR'        => $CDOCORR,
                  ':CDOPERINCLUSAO' => $CDOPERINCLUSAO,
                  ':CDOPERULTATU'   => $CDOPERULTATU,
                  ':NRORGULTATU'    => $NRORGULTATU,
                  ':NRORGINCLUSAO'  => $NRORGINCLUSAO,
                  ':DTULTATUPOCO'   => $DTULTATUPOCO,
                  ':NRORG'          => $NRORG
                );
                
                $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PRODOCORRE, $paramsSave);
            }
        } else {
            foreach ($PRODUTOS as $produto) {
                $paramsSave = array (
                  ':CDPRODUTO'      => $produto,
                  ':CDGRPOCOR'      => $CDGRPOCOR,
                  ':CDOCORR'        => $CDOCORR,
                  ':CDOPERINCLUSAO' => $CDOPERINCLUSAO,
                  ':CDOPERULTATU'   => $CDOPERULTATU,
                  ':NRORGULTATU'    => $NRORGULTATU,
                  ':NRORGINCLUSAO'  => $NRORGINCLUSAO,
                  ':DTULTATUPOCO'   => $DTULTATUPOCO,
                  ':NRORG'          => $NRORG
                );
                
                $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PRODOCORRE, $paramsSave);
            }
        }
        return $success;
    }
    
    public function deleteObsProduto($CDGRPOCOR, $CDOCORR, $CDPRODUTO, $NRORG){
        $obsProduto = array(
            'CDGRPOCOR'      => $CDGRPOCOR,
            'CDOCORR'        => $CDOCORR,
            'CDPRODUTO'      => $CDPRODUTO,
            'NRORG'          => $NRORG
        );
        $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_OBSPRODUTO, $obsProduto);
    }

    public function newRequest (DTO\Request\DataSet $request){
        $nrOrg = $request->getDataSet()->getRows()[0][self::NRORG];
        $request->getDataSet()->getRows()[0]->set(self::CDGRUPOOBRIG, $this->novoCodigo($nrOrg));
        return $request;
    }
    
    private function novoCodigo ($nrOrg){
        $novoCodigo = $this->entityManager->getConnection()->fetchAll(self::MAX_GRUPOBRIGOCOR,array(self::NRORG=>$nrOrg));
        return $novoCodigo[0][self::CDGRUPOOBRIG];
    }
    
    public function deleteGrupObrig ($rows){
        $total  = array ();
        
        foreach ($rows as $row) {
            $param = array(
                self::CDGRPOCOR => $row[self::CDGRPOCOR],
                self::CDGRUPOOBRIG => $row[self::CDGRUPOOBRIG],
                self::NRORG => $row[self::NRORG],
            );
            $this->entityManager->getConnection()->executeQuery(self::DELETE_GRUPOBRIGOCOR,$param);
            $total[]  = $row['CDGRUPOOBRIG'];
        }
        
       return $total;
    }
    
    public function saveProdObrigOcor($rows){
        try{
            $this->entityManager->getConnection()->beginTransaction();
            
            $cdGrupoObrig = $rows['CDGRUPOOBRIG'];
            foreach($rows['rows'] as $row){
	           $params = array(
	               "CDGRUPOOBRIG"=>$cdGrupoObrig,
	               "CDGRPOCOR"=>$row['CDGRPOCOR'],
	               "CDOCORR"=>$row['CDOCORR'],
	               "NRORG"=>$row['NRORG']
	           );
	           $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODOBRIGOCOR,$params);
	        }
            $this->entityManager->getConnection()->commit();
        }catch(\Exception $e){
            $this->entityManager->getConnection()->rollBack();
	        throw new \Exception($e->getMessage());
        }
    }
    
    public function deleteProdObrig ($rows){
        $total  = array ();
        
        foreach ($rows as $row) {
            $param = array(
                self::CDGRPOCOR => $row[self::CDGRPOCOR],
                self::CDGRUPOOBRIG => $row[self::CDGRUPOOBRIG],
                self::NRORG => $row[self::NRORG],
                self::CDOCORR => $row[self::CDOCORR]
            );
            $this->entityManager->getConnection()->executeQuery(self::DELETE_PRODOBRIGOCOR,$param);
            $total[]  = $row['CDGRUPOOBRIG'];
        }
        
       return $total;
    }
    
    public function updateGrupoObs($params) {
        $this->entityManager->getConnection()->executeQuery(self::UPDATE_GRUPO_OBS, $params);
    }
    
    const MAX_GRUPOBRIGOCOR  = "
        SELECT LPAD(RTRIM(NVL(MAX(TO_CHAR(TO_NUMBER(CDGRUPOOBRIG) + 1)),1)),10,'0') AS CDGRUPOOBRIG 
        FROM GRUPOBRIGOCOR WHERE NRORG = :NRORG
    ";
    
    const DELETE_GRUPOBRIGOCOR = "
        DELETE FROM GRUPOBRIGOCOR WHERE CDGRPOCOR = :CDGRPOCOR AND CDGRUPOOBRIG = :CDGRUPOOBRIG AND NRORG = :NRORG
    ";
    
    const INSERT_PRODOBRIGOCOR = "
        INSERT INTO PRODOBRIGOCOR (CDGRPOCOR,CDGRUPOOBRIG,CDOCORR,NRORG) VALUES (:CDGRPOCOR,:CDGRUPOOBRIG,:CDOCORR,:NRORG)
    ";
    
    const DELETE_PRODOBRIGOCOR = "
        DELETE FROM PRODOBRIGOCOR WHERE CDGRPOCOR = :CDGRPOCOR AND CDGRUPOOBRIG = :CDGRUPOOBRIG AND CDOCORR = :CDOCORR AND NRORG = :NRORG
    ";
    
    const UPDATE_GRUPO_OBS = "
        UPDATE GRUPOBRIGOCOR SET NMGRUPOBRIG = :NMGRUPOBRIG WHERE CDGRPOCOR = :CDGRPOCOR AND CDGRUPOOBRIG = :CDGRUPOOBRIG
    ";
    
    const GET_PRODUCTS_INI_FIN = "
        SELECT DISTINCT CDPRODUTO, CDARVPROD, NMPRODUTO, NRORG 
          FROM PRODUTO          
          WHERE NRORG = :NRORG 
          AND CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIM 
          AND CDNVPRODUTO = :CDNVPRODUTO
          AND CDPRODUTO NOT IN (SELECT CDPRODUTO FROM PRODOCORRE WHERE CDOCORR = :CDOCORR AND CDGRPOCOR = :CDGRPOCOR AND NRORG = :NRORG ) 
          ORDER BY CDARVPROD";
}    