<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\NewCode;
use Teknisa\MAN\Utilities;
use \Zeedhi\Framework\Util\Functions;

class RelVendProdCompConsService {

	public function __construct(EntityManager $entityManager, newCode $newCode) {
        $this->entityManager = $entityManager;
        $this->newCode = $newCode;
    }

    public function vendProdCompConsParamBuild($conditions){
       $params = array (      
            'P_NRORG'      => $conditions['NRORGULTATU'],
            'P_OPERADOR'   => $conditions['CDOPERULTATU'],
            'P_CDFILIAL'   => is_array($conditions['CDFILIAL']) ? $conditions['CDFILIAL'][0] : $conditions['CDFILIAL'],
            'P_CDCAIXA'    => (!$conditions['CDCAIXA']) ? 'F' : $conditions['CDCAIXA'],
            'P_TCDCAIXA'   => (!$conditions['TCDCAIXA']) ? 'F'  : $conditions['TCDCAIXA'], 
            'P_CDLOJA'     => (!$conditions['CDLOJA']) ? 'F' : $conditions['CDLOJA'],
            'P_TCDLOJA'    => (!$conditions['TCDLOJA']) ? 'F'  : $conditions['TCDLOJA'],
            'P_DTABERTUR'  => (!$conditions['DTABERTUR']) ? 'F' : $conditions['DTABERTUR'],
            'P_TDTABERTUR' => (!$conditions['TDTABERTUR']) ? 'F'  : $conditions['TDTABERTUR'],
            'P_DTINI'      => $conditions['DATAINI'],
            'P_DTFIN'      => $conditions['DATAFIN'], 
            'P_CDPRODUTO'  =>  (Functions::arrayKeyExists('CDARVPROD', $conditions)&&!empty($conditions['CDARVPROD'])) ? implode('_', $conditions['CDARVPROD']) : 'F',
            'P_TCDPRODUTO' => ($conditions['TCDPRODUTO'] !== 'T') ? 'F'  : 'T'
        );
        
        $params = array(
            'ParametersRow' => $params,
            'ReportName'    => 'relVendProdCompCons'
        );
        
        return $params;
    }
}