<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class VendasProdutosPorClienteService {

	protected $entityManager; 
	
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;

    }

	public function buscaDados($cdfilial, $dtinicial, $dtfinal, $produtoinicial, $produtofinal, $cdloja, $cdcliente, $nrorg, $idrelatorio, $cdconsumidor, $cdproduto, $cdtipocons, $clienteini, $clientefin) {

	    $params = array(
     	":P_CDFILIAL" => (is_null($cdfilial)) ? "" : $cdfilial,
     	":P_CDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ? implode('_' ,$cdloja) : "",
     	":P_CDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) ? implode('_' ,$cdcliente) : "",
     	":P_CDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ? implode('_' ,$cdconsumidor) : "",
     	":P_CDPRODUTO" => (is_array($cdproduto)  && count($cdproduto) != 0) ? implode('_' ,$cdproduto) : "",
     	":P_CDTIPOCONS" => (is_array($cdtipocons)  && count($cdtipocons) != 0) ? implode('_' ,$cdtipocons) : "",
     	":P_NOMEINI" => $clienteini,
     	":P_NOMEFIM" => $clientefin,
     	":P_DTLANCINI" => $dtinicial,
     	":P_DTLANCFIN" => $dtfinal,
     	":P_TCDPRODUTO" => (is_array($cdproduto)  && count($cdproduto) != 0) ?  "N" : "T",
     	":P_TCDTIPOCONS" => (is_array($cdtipocons)  && count($cdtipocons) != 0) ?  "N" : "T",
     	":TCDFILIAL" => (is_null($cdfilial)) ?  "T" : "N",
     	":P_TCDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ?  "N" : "T",
     	":P_TCDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) || (!is_null($clienteini) && !is_null($clientefin)) ?  "N" : "T",
     	":P_TCDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ?  "N" : "T",
     	":NRORG" => $nrorg
 		);
 		ini_set('memory_limit', '3G');
 		
 		
 		switch($idrelatorio){
            case 0:
 				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_VENDAS_PROD_CLIENTE_ANALITICO, $params);
		        return $response;
		    break;

			case 1:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_VENDAS_PROD_CLIENTE_SINTETICO, $params);
				return $response;
			break;
 		}

	}

	const BUSCA_REL_VENDAS_PROD_CLIENTE_ANALITICO = "
        SELECT 
           V.CDCLIENTE,    C.NRINSJURCLIE, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY dy') AS DTVENDA,
           F.CDFILIAL,     F.NMFILIAL,     C.NMFANTCLIE, P.CDARVPROD,
           SUM(I.QTPRODVEND) AS QTPRODVEND,NVL(I.VRUNITVEND,0) AS VRUNITVEND,
           I.CDPRODUTO,    NVL(I.VRUNITVENDCL,0) AS VRUNITVENDCL, P.NMPRODUTO,
           :P_DTLANCINI AS DTLANCINI,      :P_DTLANCFIN AS DTLANCFIN,
           C.IDTPIJURCLIE, C.CDEXCLIENTE,   
           SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
           V.CDCLIENTE || ' - ' || C.NMFANTCLIE || ' | Cód. Externo: ' || C.CDEXCLIENTE AS DSCLIENTE
        FROM
           CLIENTE C, CLIENFILIAL CF, FILIAL F, PRODUTO P,CONSUMIDOR O, VENDA V, ITEMVENDA I
        WHERE   
           (F.CDFILIAL = :P_CDFILIAL) AND
           ((INSTR(:P_CDPRODUTO, I.CDPRODUTO) <> 0) OR (:P_TCDPRODUTO = 'T')) AND
           ((INSTR(:P_CDCLIENTE, C.CDCLIENTE) > 0) OR (:P_TCDCLIENTE = 'T')  OR (C.NMRAZSOCCLIE BETWEEN :P_NOMEINI AND :P_NOMEFIM)) AND
           ((INSTR(:P_CDCONSUMIDOR, O.CDCLIENTE||O.CDCONSUMIDOR) <> 0) OR (:P_TCDCONSUMIDOR = 'T')) AND
           ((INSTR(:P_CDLOJA, V.CDFILIAL||V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T')) AND
           ((INSTR(:P_CDTIPOCONS, O.CDTIPOCONS) <> 0) OR (:P_TCDTIPOCONS = 'T')) AND
           (V.DTENTRVENDA BETWEEN :P_DTLANCINI AND :P_DTLANCFIN) AND
           (V.CDFILIAL      = F.CDFILIAL  ) AND
           (V.CDFILIAL      = I.CDFILIAL  ) AND
           (V.CDFILIAL      = CF.CDFILIAL ) AND
           (V.CDCAIXA       = I.CDCAIXA   ) AND
           (V.NRSEQVENDA    = I.NRSEQVENDA) AND
           (V.IDSITUVENDA = 'O'          ) AND
           (P.CDPRODUTO    = I.CDPRODUTO      ) AND
           (V.CDCLIENTE    = C.CDCLIENTE      ) AND
           (C.CDCLIENTE    = CF.CDCLIENTE     ) AND
           (V.CDCLIENTE    = O.CDCLIENTE(+)   ) AND
           (V.CDCONSUMIDOR = O.CDCONSUMIDOR(+))
        GROUP BY
           V.CDCLIENTE,    C.NRINSJURCLIE, V.DTENTRVENDA, F.CDFILIAL,F.NMFILIAL,
           C.NMFANTCLIE,   NVL(I.VRUNITVEND,0), P.CDARVPROD,
           I.CDPRODUTO,    NVL(I.VRUNITVENDCL,0), P.NMPRODUTO,
           C.IDTPIJURCLIE, C.CDEXCLIENTE  
        ORDER BY V.CDCLIENTE, V.DTENTRVENDA, I.CDPRODUTO
    ";
    
	const BUSCA_REL_VENDAS_PROD_CLIENTE_SINTETICO = "
        SELECT 
           FI.CDFILIAL, FI.NMFILIAL, CL.CDCLIENTE,CL.NMRAZSOCCLIE,
           PR.CDPRODUTO, PR.NMPRODUTO, PR.SGUNIDADE,IT.VRUNITVEND AS VALORCONS,IT.VRUNITVENDCL AS VALORCLIE,
           SUM(QTPRODVEND) AS QTDE, PR.CDARVPROD,
           SUM(TRUNC(IT.QTPRODVEND * (NVL(IT.VRUNITVEND,0) + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRTOTAL,
           CL.CDCLIENTE || ' - ' || CL.NMRAZSOCCLIE AS DSCLIENTE
        FROM
           CLIENTE CL, CLIENFILIAL CF, CONSUMIDOR CO, PRODUTO PR, FILIAL FI, VENDA VE, ITEMVENDA IT
        WHERE
           (VE.CDFILIAL     = :P_CDFILIAL    ) AND
           (VE.DTENTRVENDA BETWEEN :P_DTLANCINI AND :P_DTLANCFIN) AND
           ((INSTR(:P_CDPRODUTO, PR.CDPRODUTO) <> 0) OR (:P_TCDPRODUTO = 'T')) AND   
           ((INSTR(:P_CDCLIENTE, VE.CDCLIENTE) > 0) OR (:P_TCDCLIENTE = 'T')  OR (CL.NMRAZSOCCLIE BETWEEN :P_NOMEINI AND :P_NOMEFIM)) AND
           ((INSTR(:P_CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:P_TCDCONSUMIDOR = 'T')) AND
           ((INSTR(:P_CDLOJA, VE.CDFILIAL||VE.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T')) AND
           ((INSTR(:P_CDTIPOCONS,   CO.CDTIPOCONS  ) <> 0) OR (:P_TCDTIPOCONS = 'T'  )) AND
           (VE.IDSITUVENDA = 'O'            ) AND
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND
           (VE.CDFILIAL     = CF.CDFILIAL    ) AND
           (CL.CDCLIENTE    = CF.CDCLIENTE   ) AND
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (VE.CDFILIAL     = FI.CDFILIAL    ) AND
           (IT.CDPRODUTO    = PR.CDPRODUTO   ) AND
           (VE.CDCLIENTE    = CL.CDCLIENTE   ) AND
           (VE.CDCLIENTE    = CO.CDCLIENTE   (+)) AND
           (VE.CDCONSUMIDOR = CO.CDCONSUMIDOR(+))
        GROUP BY
           CL.CDCLIENTE,CL.NMRAZSOCCLIE,PR.CDPRODUTO, PR.NMPRODUTO, PR.SGUNIDADE,FI.CDFILIAL, 
           FI.NMFILIAL, IT.VRUNITVEND, IT.VRUNITVENDCL, PR.CDARVPROD
        ORDER BY CL.CDCLIENTE, PR.CDPRODUTO
    ";
}  